﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace IT_Rex
{
    public partial class ClientAdd : Form
    {
        public static string[] add_client = new string[1];
        DataBase dataBase = new DataBase();
        public ClientAdd()
        {
            InitializeComponent();
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSetContract.Contract". При необходимости она может быть перемещена или удалена.
            this.contractTableAdapter.Fill(this.pP_PigalevDataSetContract.Contract);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSet_Pol.Pol". При необходимости она может быть перемещена или удалена.
            this.polTableAdapter.Fill(this.pP_PigalevDataSet_Pol.Pol);
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            Client client = new Client();
            client.ShowDialog();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }
        private void button_save_Click(object sender, EventArgs e) // Добавление данных
        {
            string sqccommand_contract = $"SELECT id_contract From Contract WHERE contract = '{textContract.Text}'"; // Проверка, что контракт выбран из списка
            SqlDataAdapter sda_contract = new SqlDataAdapter(sqccommand_contract, dataBase.GetConnection());
            DataTable dtbl_contract = new DataTable();
            sda_contract.Fill(dtbl_contract);
            if (dtbl_contract.Rows.Count == 0 && textContract.Text != "") MessageBox.Show("Поле договор должно быть выбрано из списка");
            else
            {
                string sqccommand_pol = $"SELECT id_pol From Pol WHERE pol = '{textPol.Text}'"; // Проверка, что пол выбран из списка
                SqlDataAdapter sda_pol = new SqlDataAdapter(sqccommand_pol, dataBase.GetConnection());
                DataTable dtbl_pol = new DataTable();
                sda_pol.Fill(dtbl_pol);
                if (dtbl_pol.Rows.Count == 0) MessageBox.Show("Поле пол должно быть выбрано из списка");
                else
                {
                    if (textNameOrganization.Text.Replace(" ", "") == "") MessageBox.Show("Поле наименование не может быть пустым");
                    else if (textSurname.Text.Replace(" ", "") == "") MessageBox.Show("Поле фамилия не может быть пустым");
                    else if (textName.Text.Replace(" ", "") == "") MessageBox.Show("Поле имя не может быть пустым");
                    else if (textPatronomic.Text.Replace(" ", "") == "") MessageBox.Show("Поле отчество не может быть пустым");
                    else if (textAddress.Text.Replace(" ", "") == "") MessageBox.Show("Поле адресс не может быть пустым");
                    else if (textEmail.Text != "" && textEmail.Text.IndexOf('@') == -1) MessageBox.Show("Поле email должно содержать символ '@'");
                    else
                    {
                        dataBase.openConnection();
                        SqlCommand sqlCommand_pol = new SqlCommand(sqccommand_pol, dataBase.GetConnection());
                        string id_pol = sqlCommand_pol.ExecuteScalar().ToString();
                        if (textContract.Text != "") // Если контракт не указан
                        {
                            SqlCommand sqlCommand_contract = new SqlCommand(sqccommand_contract, dataBase.GetConnection());
                            string id_contract = sqlCommand_contract.ExecuteScalar().ToString();
                            var addQuery = $"insert into Client (name_organization, address, surname, name, patronymic, id_pol, phone, email, id_contract, comment) values ('{textNameOrganization.Text}','{textAddress.Text}','{textSurname.Text}', '{textName.Text}', '{textPatronomic.Text}', '{id_pol}', '{textPhone.Text}', '{textEmail.Text}', '{id_contract}', '{textComment.Text}')";
                            var command = new SqlCommand(addQuery, dataBase.GetConnection());
                            command.ExecuteNonQuery();
                        }
                        else // Если контракт указан
                        {
                            var addQuery = $"insert into Client (name_organization, address, surname, name, patronymic, id_pol, phone, email, comment) values ('{textNameOrganization.Text}','{textAddress.Text}','{textSurname.Text}', '{textName.Text}', '{textPatronomic.Text}', '{id_pol}', '{textPhone.Text}', '{textEmail.Text}', '{textComment.Text}')";
                            var command = new SqlCommand(addQuery, dataBase.GetConnection());
                            command.ExecuteNonQuery();
                        }
                        MessageBox.Show("Запись успешно добавлена в таблицу");
                        // Уввеличения массивов для вывода в Debug
                        add_client[add_client.Length-1] = textNameOrganization.Text;
                        Array.Resize(ref add_client, add_client.Length + 1);
                        //
                        textNameOrganization.Text = "";
                        textAddress.Text = "";
                        textSurname.Text = "";
                        textName.Text = "";
                        textPatronomic.Text = "";
                        textPhone.Text = "";
                        textEmail.Text = "";
                        textContract.Text = "";
                        textComment.Text = "";
                        dataBase.closeConnection();
                    }
                }
            }
        }

        private void textPhone_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8) // цифры
            {
                e.Handled = true;
            }
        }

        private void ClientAdd_Load(object sender, EventArgs e)
        {
            textContract.Text = "";
        }
    }
}
