﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class ContractUpd : Form
    {
        string id_contract;
        public static string[] upd_contract = new string[1];
        DataBase dataBase = new DataBase();
        public ContractUpd(string id_contract, string contract, string cena, string percent, string count_hours)
        {
            InitializeComponent();
            textName.Text = contract;
            textPrice.Text = cena;
            textPercent.Text = percent;
            textCountHours.Text = count_hours;
            this.id_contract = id_contract;
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            Contract contract = new Contract();
            contract.ShowDialog();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button_save_Click(object sender, EventArgs e) // Принятие изменений
        {
            if (textName.Text.Replace(" ", "") == "") MessageBox.Show("Поле наименование не может быть пустым");
            else if (textPrice.Text.Replace(" ", "") == "0") MessageBox.Show("Поле цена не может быть равен '0'");
            else
            {
                dataBase.openConnection();
                var addQuery = $"update Contract set contract = '{textName.Text}', cena = cast('{textPrice.Text.Replace(',', '.')}' as float), [percent] = cast('{textPercent.Text.Replace(',', '.')}' as float), count_hours = cast('{textCountHours.Text.Replace(',', '.')}' as float)  where id_contract = '{id_contract}'";
                var command = new SqlCommand(addQuery, dataBase.GetConnection());
                command.ExecuteNonQuery();
                MessageBox.Show("Запись успешно изменена");
                // Уввеличения массивов для вывода в Debug
                upd_contract[upd_contract.Length-1] = textName.Text;
                Array.Resize(ref upd_contract, upd_contract.Length + 1);
                //
                dataBase.closeConnection();
                this.Hide();
                Contract contract = new Contract();
                contract.ShowDialog();
            }
        }

        private void textPercent_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8 && !(e.KeyChar == ',')) // цифры, клавиша BackSpace и ","
            {
                e.Handled = true;
            }
        }

        private void textPrice_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8 && !(e.KeyChar == ',')) // цифры, клавиша BackSpace и ","
            {
                e.Handled = true;
            }
        }
        private void textPrice_Enter(object sender, EventArgs e)
        {
            if (textPrice.ForeColor == Color.Gray)
            {
                textPrice.Text = null;
                textPrice.ForeColor = Color.Black;
            }
        }
        private void textPrice_Leave(object sender, EventArgs e)
        {
            if (textPrice.Text == "")
            {
                textPrice.Text = "0";
                textPrice.ForeColor = Color.Gray;
            }
        }

        private void textPercent_Enter(object sender, EventArgs e)
        {
            if (textPercent.ForeColor == Color.Gray)
            {
                textPercent.Text = null;
                textPercent.ForeColor = Color.Black;
            }
        }

        private void textPercent_Leave(object sender, EventArgs e)
        {
            if (textPercent.Text == "")
            {
                textPercent.Text = "0";
                textPercent.ForeColor = Color.Gray;
            }
        }

        private void textPercent_TextChanged(object sender, EventArgs e)
        {
            if (textPercent.TextLength > 1)
            {
                string text = textPercent.Text.Substring(0, textPercent.Text.Length - 1);
                if (ContractAdd.GetCount(textPercent.Text) > 2)
                {
                    textPercent.Text = text;
                    textPercent.SelectionStart = textPercent.Text.Length;
                }
            }
        }

        private void textPrice_TextChanged(object sender, EventArgs e)
        {
            if (textPrice.TextLength > 1)
            {
                string text = textPrice.Text.Substring(0, textPrice.Text.Length - 1);
                if (ContractAdd.GetCount(textPrice.Text) > 2)
                {
                    textPrice.Text = text;
                    textPrice.SelectionStart = textPrice.Text.Length;
                }
            }
        }

        private void textCountHours_TextChanged(object sender, EventArgs e)
        {
            if (textCountHours.TextLength > 1)
            {
                string text = textCountHours.Text.Substring(0, textCountHours.Text.Length - 1);
                if (ContractAdd.GetCount(textCountHours.Text) > 2)
                {
                    textCountHours.Text = text;
                    textCountHours.SelectionStart = textCountHours.Text.Length;
                }
            }
        }

        private void textCountHours_Enter(object sender, EventArgs e)
        {
            if (textCountHours.ForeColor == Color.Gray)
            {
                textCountHours.Text = null;
                textCountHours.ForeColor = Color.Black;
            }
        }

        private void textCountHours_Leave(object sender, EventArgs e)
        {
            if (textCountHours.Text == "")
            {
                textCountHours.Text = "0";
                textCountHours.ForeColor = Color.Gray;
            }
        }

        private void textCountHours_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8 && !(e.KeyChar == ',')) // цифры, клавиша BackSpace и ","
            {
                e.Handled = true;
            }
        }
    }
}
