﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class Salary : Form // Форма подсчёта ЗП
    {
        DataBase dataBase = new DataBase();
        public Salary()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Hide();
            MainMenu main = new MainMenu();
            main.ShowDialog();
        }

        private void Salary_Load(object sender, EventArgs e)
        {
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSetEmployee.Employee". При необходимости она может быть перемещена или удалена.
            this.employeeTableAdapter.Fill(this.pP_PigalevDataSetEmployee.Employee);
        }

        private void buttonSalary_Click(object sender, EventArgs e) // Процесс подсчёта ЗП
        {
            dataBase.openConnection();
            string sqccommand_employee = $"SELECT id_employee From Employee WHERE surname = '{textEmployee.Text}'"; // Проверка, что сотрудник выбран из списка
            SqlDataAdapter sda_employee = new SqlDataAdapter(sqccommand_employee, dataBase.GetConnection());
            DataTable dtbl_employee = new DataTable();
            sda_employee.Fill(dtbl_employee);
            if (dtbl_employee.Rows.Count == 0) MessageBox.Show("Поле сотрудник должно быть выбрано из списка");
            else
            {
                string searchString = $"Select W.complexity From Work W inner join Employee E ON W.id_employee = E.id_employee Where E.surname = '{textEmployee.Text}' and W.data_end > '{Convert.ToDateTime(textData_start.Text)}' and W.data_end < '{Convert.ToDateTime(textDate_end.Text)}'";
                SqlCommand com = new SqlCommand(searchString, dataBase.GetConnection());
                dataBase.openConnection();
                SqlDataReader read = com.ExecuteReader();
                double[] TimeWorked = new double[0];
                int i = 0;
                while (read.Read())
                {
                    Array.Resize(ref TimeWorked, TimeWorked.Length + 1);
                    TimeWorked[i] = read.GetDouble(0);
                    i++;
                }
                read.Close();
                double kolvo = GetSummaMassive(TimeWorked);
                double result = GetSalary(kolvo);
                labelResult.Text = $"Сотрудник {textEmployee.Text} за период с {textData_start.Text}\nпо {textDate_end.Text} заработал {result} рублей";
            }
            dataBase.closeConnection();
        }
        public static double GetSalary(double kolvo) // Метод для подсчёта заработной платы за определённое количество часов
        {
            double summa = 0;
            summa = kolvo * 350;
            return summa;
        }
        public static double GetSummaMassive(double[] massive) // Метод для подсчёта суммы элементов массива
        {
            double summa = 0;
            for (int i = 0; i < massive.Length; i++)
            {
                summa += massive[i];
            }
            return summa;
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }
    }
}
