﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using IT_Rex;

namespace UnitTests
{
    [TestClass]
    public class UnitTest1
    {
        // Метод для подсчёта суммы
        [TestMethod]
        public void a5_b3_5_GetSumma_return17_5() // успешное прохождение теста
        {
            double a = 5;
            double b = 3.5;
            double expected = 17.5;
            double act = OrderUpplierAdd.GetSumma(a, b);
            Assert.AreEqual(expected, act);
        }
        [TestMethod]
        public void a8_b2_GetSumma_return10() // не успешное прохождение теста
        {
            double a = 8;
            double b = 2;
            double expected = 10;
            double act = OrderUpplierAdd.GetSumma(a, b);
            Assert.AreEqual(expected, act);
        }
        /////////////////////
        // Метод для подсчёта количества символов после ","
        [TestMethod]
        public void aСлово__не_воробей_GetCount_return11() // успешное прохождение теста
        {
            string a = "Слово, не воробей";
            double expected = 11;
            double act = ContractAdd.GetCount(a);
            Assert.AreEqual(expected, act);
        }
        [TestMethod]
        public void aсчастье__подарок_GetCount_return15() // не успешное прохождение теста
        {
            string a = "Счастье, подарок";
            double expected = 15;
            double act = ContractAdd.GetCount(a);
            Assert.AreEqual(expected, act);
        }
        //////////////////////////////
        // Метод для подсчёта суммы со скидкой
        [TestMethod]
        public void a3600_b5_5_GetDiscount_return3402() // успешное прохождение теста
        {
            double a = 3600;
            double b = 5.5;
            double expected = 3402;
            double act = WorkAdd.GetDiscount(a, b);
            Assert.AreEqual(expected, act);
        }
        [TestMethod]
        public void a2550_b2_3_GetDiscount_return2100() //не успешное прохождение теста
        {
            double a = 2550;
            double b = 2.3;
            double expected = 2100;
            double act = WorkAdd.GetDiscount(a, b);
            Assert.AreEqual(expected, act);
        }
        //////////////////////////
        // Метод для подсчёта заработной платы за определённое количество часов
        [TestMethod]
        public void a12_5_GetSalary_return4375() // успешное прохождение теста
        {
            double a = 12.5;
            double expected = 4375;
            double act = Salary.GetSalary(a);
            Assert.AreEqual(expected, act);
        }
        [TestMethod]
        public void a15_GetSalary_return3200() // не успешное прохождение теста
        {
            double a = 15;
            double expected = 3200;
            double act = Salary.GetSalary(a);
            Assert.AreEqual(expected, act);
        }
        //////////////////////////
        // Метод для подсчёта суммы элементов массива
        [TestMethod]
        public void a5_8_2_1_17_GetSummaMassive_return33() // успешное прохождение теста
        {
            double[] a = new double[5];
            a[0] = 5;
            a[1] = 8;
            a[2] = 2;
            a[3] = 1;
            a[4] = 17;
            double expected = 33;
            double act = Salary.GetSummaMassive(a);
            Assert.AreEqual(expected, act);
        }
        [TestMethod]
        public void a6_8_1_7_GetSummaMassive_return25() // не успешное прохождение теста
        {
            double[] a = new double[4];
            a[0] = 6;
            a[1] = 8;
            a[2] = 1;
            a[3] = 7;
            double expected = 25;
            double act = Salary.GetSummaMassive(a);
            Assert.AreEqual(expected, act);
        }
        ///////////////////
    }
}
