﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class ClientUpd : Form
    {
        string id_client;
        public static string[] upd_client = new string[1];
        DataBase dataBase = new DataBase();
        public ClientUpd(string id_client, string name_organization, string address, string phone, string email)
        {
            InitializeComponent();
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSetContract.Contract". При необходимости она может быть перемещена или удалена.
            this.contractTableAdapter.Fill(this.pP_PigalevDataSetContract.Contract);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSet_Pol.Pol". При необходимости она может быть перемещена или удалена.
            this.polTableAdapter.Fill(this.pP_PigalevDataSet_Pol.Pol);
            textNameOrganization.Text = name_organization;
            textAddress.Text = address;
            textPhone.Text = phone;
            textEmail.Text = email;
            this.id_client = id_client;
            // Вывод всех данных
            dataBase.openConnection();
            SqlCommand sqlCommand_surname = new SqlCommand($"Select surname From Client Where id_client = '{id_client}'", dataBase.GetConnection());
            textSurname.Text = sqlCommand_surname.ExecuteScalar().ToString();
            SqlCommand sqlCommand_name = new SqlCommand($"Select name From Client Where id_client = '{id_client}'", dataBase.GetConnection());
            textName.Text = sqlCommand_name.ExecuteScalar().ToString();
            SqlCommand sqlCommand_patronymic = new SqlCommand($"Select patronymic From Client Where id_client = '{id_client}'", dataBase.GetConnection());
            textPatronomic.Text = sqlCommand_patronymic.ExecuteScalar().ToString();
            SqlCommand sqlCommand_pol = new SqlCommand($"Select P.pol From Client Cl inner join Pol P ON Cl.id_pol = P.id_pol Where Cl.id_client = '{id_client}'", dataBase.GetConnection());
            textPol.Text = sqlCommand_pol.ExecuteScalar().ToString();
            SqlCommand sqlCommand_comment = new SqlCommand($"Select comment From Client Where id_client = '{id_client}'", dataBase.GetConnection());
            textComment.Text = sqlCommand_comment.ExecuteScalar().ToString();
            dataBase.closeConnection();
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            Client client = new Client();
            client.ShowDialog();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button_save_Click(object sender, EventArgs e) // Применение измененией
        {
            string sqccommand_contract = $"SELECT id_contract From Contract WHERE contract = '{textContract.Text}'"; // Проверка, что контракт выбран из списка
            SqlDataAdapter sda_contract = new SqlDataAdapter(sqccommand_contract, dataBase.GetConnection());
            DataTable dtbl_contract = new DataTable();
            sda_contract.Fill(dtbl_contract);
            if (dtbl_contract.Rows.Count == 0 && textContract.Text != "") MessageBox.Show("Поле договор должно быть выбрано из списка");
            else
            {
                string sqccommand_pol = $"SELECT id_pol From Pol WHERE pol = '{textPol.Text}'"; // Проверка, что пол выбран из списка
                SqlDataAdapter sda_pol = new SqlDataAdapter(sqccommand_pol, dataBase.GetConnection());
                DataTable dtbl_pol = new DataTable();
                sda_pol.Fill(dtbl_pol);
                if (dtbl_pol.Rows.Count == 0) MessageBox.Show("Поле пол должно быть выбрано из списка");
                else
                {
                    if (textNameOrganization.Text.Replace(" ", "") == "") MessageBox.Show("Поле наименование не может быть пустым");
                    else if (textSurname.Text.Replace(" ", "") == "") MessageBox.Show("Поле фамилия не может быть пустым");
                    else if (textName.Text.Replace(" ", "") == "") MessageBox.Show("Поле имя не может быть пустым");
                    else if (textPatronomic.Text.Replace(" ", "") == "") MessageBox.Show("Поле отчество не может быть пустым");
                    else if (textAddress.Text.Replace(" ", "") == "") MessageBox.Show("Поле адресс не может быть пустым");
                    else if (textEmail.Text != "" && textEmail.Text.IndexOf('@') == -1) MessageBox.Show("Поле email должно содержать символ '@'");
                    else
                    {
                        dataBase.openConnection();
                        SqlCommand sqlCommand_pol = new SqlCommand(sqccommand_pol, dataBase.GetConnection());
                        string id_pol = sqlCommand_pol.ExecuteScalar().ToString();
                        if (textContract.Text != "") // Если контракт не указан
                        {
                            SqlCommand sqlCommand_contract = new SqlCommand(sqccommand_contract, dataBase.GetConnection());
                            string id_contract = sqlCommand_contract.ExecuteScalar().ToString();
                            var addQuery = $"update Client set name_organization = '{textNameOrganization.Text}', address = '{textAddress.Text}', surname = '{textSurname.Text}', name = '{textName.Text}', patronymic = '{textPatronomic.Text}', id_pol = '{id_pol}', phone = '{textPhone.Text}', email = '{textEmail.Text}', id_contract = '{id_contract}', comment = '{textComment.Text}' where id_client = '{id_client}'";
                            var command = new SqlCommand(addQuery, dataBase.GetConnection());
                            command.ExecuteNonQuery();
                        }
                        else // Если контракт указан
                        {
                            var addQuery = $"update Client set name_organization = '{textNameOrganization.Text}', address = '{textAddress.Text}', surname = '{textSurname.Text}', name = '{textName.Text}', patronymic = '{textPatronomic.Text}', id_pol = '{id_pol}', phone = '{textPhone.Text}', email = '{textEmail.Text}', id_contract = null, comment = '{textComment.Text}' where id_client = '{id_client}'";
                            var command = new SqlCommand(addQuery, dataBase.GetConnection());
                            command.ExecuteNonQuery();
                        }
                        MessageBox.Show("Запись успешно изменена");
                        // Уввеличения массивов для вывода в Debug
                        upd_client[upd_client.Length-1] = textNameOrganization.Text;
                        Array.Resize(ref upd_client, upd_client.Length + 1);
                        //
                        this.Hide();
                        Client client = new Client();
                        client.ShowDialog();
                        dataBase.closeConnection();
                    }
                }
            }
        }

        private void textPhone_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8) // цифры
            {
                e.Handled = true;
            }
        }

        private void ClientUpd_Load(object sender, EventArgs e)
        {
            // Вывод договора
            dataBase.openConnection();
            SqlCommand sqlCommand_id_contract = new SqlCommand($"Select id_contract From Client Where id_client = '{id_client}'", dataBase.GetConnection());
            if (sqlCommand_id_contract.ExecuteScalar().ToString() != "")
            {
                SqlCommand sqlCommand_contract = new SqlCommand($"Select contract From Contract Where id_contract = '{sqlCommand_id_contract.ExecuteScalar().ToString()}'", dataBase.GetConnection());
                textContract.Text = sqlCommand_contract.ExecuteScalar().ToString();
            }
            else
            {
                textContract.Text = "";
            }
            dataBase.closeConnection();
        }
    }
}
