﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class ContractAdd : Form // Форма добавления нового договора
    {
        public static string[] add_contract = new string[1];
        DataBase dataBase = new DataBase();
        public ContractAdd()
        {
            InitializeComponent();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }
        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            Contract contract = new Contract();
            contract.ShowDialog();
        }

        public static int GetCount(string text) // метод для подсчёта количества символов после ","
        {
            int k = 0; ;
            for (int i = 0; i < text.Length; i++)
            {
                if (text[i] == ',')
                {
                    for (int j = i+1; j < text.Length; j++)
                    {
                        k++;
                    }
                }
            }
            return k;
        }

        private void button_save_Click(object sender, EventArgs e) // Сохранение данных
        {
            if (textName.Text.Replace(" ", "") == "") MessageBox.Show("Поле наименование не может быть пустым");
            else if (textPrice.Text.Replace(" ", "") == "0") MessageBox.Show("Поле цена не может быть равна '0'");
            else
            {
                dataBase.openConnection();
                var addQuery = $"insert into Contract (contract, cena, [percent], count_hours) values ('{textName.Text}', cast('{textCountHours.Text.Replace(',', '.')}' as float), cast('{textPercent.Text.Replace(',', '.')}' as float), cast('{textCountHours.Text.Replace(',', '.')}' as float))";
                var command = new SqlCommand(addQuery, dataBase.GetConnection());
                command.ExecuteNonQuery();
                MessageBox.Show("Запись успешно добавлена в таблицу");
                // Увеличения массивов для вывода в Debug
                add_contract[add_contract.Length-1] = textName.Text;
                Array.Resize(ref add_contract, add_contract.Length + 1);
                // Обнуление полей
                textName.Text = "";
                textPercent.Text = "0";
                textPercent.ForeColor = Color.Gray;
                textPrice.Text = "0";
                textPrice.ForeColor = Color.Gray;
                textCountHours.Text = "0";
                textCountHours.ForeColor = Color.Gray;
                dataBase.closeConnection();
            }
        }

        private void textPercent_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8 && !(e.KeyChar == ',')) // цифры, клавиша BackSpace и ","
            {
                e.Handled = true;
            }
        }

        private void textPrice_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8 && !(e.KeyChar == ',')) // цифры, клавиша BackSpace и ","
            {
                e.Handled = true;
            }
        }

        private void textPercent_TextChanged(object sender, EventArgs e)
        {
            if (textPercent.TextLength > 1)
            {
                string text = textPercent.Text.Substring(0, textPercent.Text.Length - 1);
                if (ContractAdd.GetCount(textPercent.Text) > 2)
                {
                    textPercent.Text = text;
                    textPercent.SelectionStart = textPercent.Text.Length;
                }
            }
        }

        private void textPrice_TextChanged(object sender, EventArgs e)
        {
            if (textPrice.TextLength > 1)
            {
                string text = textPrice.Text.Substring(0, textPrice.Text.Length - 1);
                if (ContractAdd.GetCount(textPrice.Text) > 2)
                {
                    textPrice.Text = text;
                    textPrice.SelectionStart = textPrice.Text.Length;
                }
            }
        }

        private void textPrice_Enter(object sender, EventArgs e)
        {
            if (textPrice.ForeColor == Color.Gray)
            {
                textPrice.Text = null;
                textPrice.ForeColor = Color.Black;
            }
        }

        private void textPrice_Leave(object sender, EventArgs e)
        {
            if (textPrice.Text == "")
            {
                textPrice.Text = "0";
                textPrice.ForeColor = Color.Gray;
            }
        }

        private void textPercent_Enter(object sender, EventArgs e)
        {
            if (textPercent.ForeColor == Color.Gray)
            {
                textPercent.Text = null;
                textPercent.ForeColor = Color.Black;
            }
        }

        private void textPercent_Leave(object sender, EventArgs e)
        {
            if (textPercent.Text == "")
            {
                textPercent.Text = "0";
                textPercent.ForeColor = Color.Gray;
            }
        }

        private void ContractAdd_Load(object sender, EventArgs e)
        {
            textPercent.Text = "0";
            textPercent.ForeColor = Color.Gray;
            textPrice.Text = "0";
            textPrice.ForeColor = Color.Gray;
            textCountHours.Text = "0";
            textCountHours.ForeColor = Color.Gray;
        }

        private void textCountHours_TextChanged(object sender, EventArgs e)
        {
            if (textCountHours.TextLength > 1)
            {
                string text = textCountHours.Text.Substring(0, textCountHours.Text.Length - 1);
                if (ContractAdd.GetCount(textCountHours.Text) > 2)
                {
                    textCountHours.Text = text;
                    textCountHours.SelectionStart = textCountHours.Text.Length;
                }
            }
        }

        private void textCountHours_Enter(object sender, EventArgs e)
        {
            if (textCountHours.ForeColor == Color.Gray)
            {
                textCountHours.Text = null;
                textCountHours.ForeColor = Color.Black;
            }
        }

        private void textCountHours_Leave(object sender, EventArgs e)
        {
            if (textCountHours.Text == "")
            {
                textCountHours.Text = "0";
                textCountHours.ForeColor = Color.Gray;
            }
        }

        private void textCountHours_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8 && !(e.KeyChar == ',')) // цифры, клавиша BackSpace и ","
            {
                e.Handled = true;
            }
        }
    }
}
