﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class EmployeeAdd : Form // Форма для добавления данных
    {
        public static string[] add_login = new string[1];
        DataBase dataBase = new DataBase();
        public EmployeeAdd()
        {
            InitializeComponent();
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            Employee employee = new Employee();
            employee.ShowDialog();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }
        private void EmployeeAdd_Load(object sender, EventArgs e)
        {
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSet_Pol.Pol". При необходимости она может быть перемещена или удалена.
            this.polTableAdapter.Fill(this.pP_PigalevDataSet_Pol.Pol);
            string searchString = $"Select role From Role Where Not role = 'Администратор'";
            SqlCommand com = new SqlCommand(searchString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader read = com.ExecuteReader();
            while (read.Read())
            {
                textRole.Items.Add(read.GetString(0));
            }
            read.Close();
            dataBase.closeConnection();
        }

        private void button_save_Click(object sender, EventArgs e) // Добавление в БД внесённых данных
        {
            string sqccommand_pol = $"SELECT id_pol From Pol WHERE pol = '{text_id_pol.Text}'"; // Проверка, что пол выбран из списка
            SqlDataAdapter sda = new SqlDataAdapter(sqccommand_pol, dataBase.GetConnection());
            string sqccommand_role = $"SELECT id_role From Role WHERE role = '{textRole.Text}'"; // Проверка, что роль выбрана из списка
            SqlDataAdapter sda_role = new SqlDataAdapter(sqccommand_role, dataBase.GetConnection());
            Regex rg = new Regex("^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d)(?=.*[^\\da-zA-Z]).{4,15}$"); // Регулярное выражение
            string pass = textPassword.Text;
            DataTable dtbl = new DataTable();
            sda.Fill(dtbl);
            DataTable dtbl1 = new DataTable();
            sda_role.Fill(dtbl1);
            if (dtbl.Rows.Count == 0) MessageBox.Show("Поле пол должно быть выбрано из списка");
            else if (dtbl1.Rows.Count == 0) MessageBox.Show("Поле роль должно быть выбрано из списка");
            else if (surname.Text.Replace(" ", "") == "") MessageBox.Show("Поле фамилия не может быть пустым");
            else if (name.Text.Replace(" ", "") == "") MessageBox.Show("Поле имя не может быть пустым");
            else if (patronymic.Text.Replace(" ", "") == "") MessageBox.Show("Поле отчество не может быть пустым");
            else if (date_of_birth.Text.Replace(" ", "") == "") MessageBox.Show("Поле дата рождения не может быть пустым");
            else if (phone.Text.Replace(" ", "") == "") MessageBox.Show("Поле телефон не может быть пустым");
            else if (text_login.Text.Replace(" ", "") == "") MessageBox.Show("Поле логин не может быть пустым");
            else if (textPassword.Text.Replace(" ", "") == "") MessageBox.Show("Поле пароль не может быть пустым");
            else if (textSeries.Text.Replace(" ", "") == "") MessageBox.Show("Поле серия не может быть пустым");
            else if (textNomer.Text.Replace(" ", "") == "") MessageBox.Show("Поле номер не может быть пустым");
            else if (textWhoIssued.Text.Replace(" ", "") == "") MessageBox.Show("Поле кем выдано не может быть пустым");
            else if (textDateIssued.Text.Replace(" ", "") == "") MessageBox.Show("Поле дата выдачи не может быть пустым");
            else if (textRegistration.Text.Replace(" ", "") == "") MessageBox.Show("Поле прописка не может быть пустым");
            else if (textSeries.TextLength != 4) MessageBox.Show("Поле серия паспорта должно иметь 4 цифры");
            else if (textNomer.TextLength != 6) MessageBox.Show("Поле номер паспорта должно иметь 6 цифр");
            else
            {
                string sqccommand_login = $"SELECT login From Employee WHERE login = '{text_login.Text}'"; // Проверка, что пользователя с таким логиным нет
                SqlDataAdapter sda2 = new SqlDataAdapter(sqccommand_login, dataBase.GetConnection());
                DataTable dtbl2 = new DataTable();
                sda2.Fill(dtbl2);
                if (dtbl2.Rows.Count > 0)
                {
                    MessageBox.Show("Пользователь с таким логиным уже зарегистрирован");
                }
                else
                {
                    string sqccommand_passport = $"SELECT id_passport From PassportData WHERE series = '{textSeries.Text}' and number = '{textNomer.Text}'"; // Проверка, что паспортных данных таких уже нет
                    SqlDataAdapter sda3 = new SqlDataAdapter(sqccommand_passport, dataBase.GetConnection());
                    DataTable dtbl3 = new DataTable();
                    sda3.Fill(dtbl3);
                    if (dtbl3.Rows.Count > 0)
                    {
                        MessageBox.Show("Пользователь с такими паспортными данными уже зарегистрирован в системе");
                    }
                    else if (rg.IsMatch(pass))
                    {
                        dataBase.openConnection();
                        SqlCommand sqlCommand_pol = new SqlCommand(sqccommand_pol, dataBase.GetConnection());
                        var id_pol = sqlCommand_pol.ExecuteScalar().ToString();
                        Shifr.phraze = textPassword.Text;
                        Shifr myTeloInfo = new Shifr(); // Шифрование введённого пароля
                        myTeloInfo.ShifrCode();
                        string password = "";
                        for (int i = 0; i < Shifr.codePhraze.Length; i++)
                        {
                            password = password + " " + Shifr.codePhraze[i];
                        }
                        var addQuery1 = $"insert into PassportData (series, number, who_issued, date_issued, registration) values ('{textSeries.Text}','{textNomer.Text}','{textWhoIssued.Text}', '{Convert.ToDateTime(textDateIssued.Text)}','{textRegistration.Text}')";
                        var command1 = new SqlCommand(addQuery1, dataBase.GetConnection());
                        command1.ExecuteNonQuery();
                        SqlCommand sqlCommand_password = new SqlCommand($"Select id_passport From PassportData Where series = '{textSeries.Text}' and number = '{textNomer.Text}'", dataBase.GetConnection());
                        string id_password = sqlCommand_password.ExecuteScalar().ToString();
                        SqlCommand sqlCommand_role = new SqlCommand(sqccommand_role, dataBase.GetConnection());
                        string id_role = sqlCommand_role.ExecuteScalar().ToString();
                        var addQuery = $"insert into Employee (surname, name, patronymic, id_pol, id_passport, id_role, date_of_birth, login, password, phone, сomments) values ('{surname.Text}','{name.Text}','{patronymic.Text}', '{id_pol}', '{id_password}', '{id_role}','{Convert.ToDateTime(date_of_birth.Text)}', '{text_login.Text}', '{password}', '{phone.Text}', '{textComment.Text}')";
                        var command = new SqlCommand(addQuery, dataBase.GetConnection());
                        command.ExecuteNonQuery();
                        MessageBox.Show("Запись успешно добавлена в таблицу");
                        // Уввеличения массивов для вывода в Debug
                        add_login[add_login.Length-1] = text_login.Text;
                        Array.Resize(ref add_login, add_login.Length + 1);
                        // Очистка всех полей
                        surname.Text = "";
                        name.Text = "";
                        patronymic.Text = "";
                        date_of_birth.Text = "";
                        phone.Text = "";
                        textRole.Text = "";
                        text_login.Text = "";
                        textPassword.Text = "";
                        textComment.Text = "";
                        textSeries.Text = "";
                        textNomer.Text = "";
                        textWhoIssued.Text = "";
                        textDateIssued.Text = "";
                        textRegistration.Text = "";
                        dataBase.closeConnection();
                    }
                    else
                    {
                        MessageBox.Show("Пароль не соответствует требованиям!");
                    }
                }
            }
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            if(panel.Visible == true)
            {
                panel.Visible = false;
            }
            else
            {
                panel.Visible = true;
            }
        }

        private void labelPassport_Click(object sender, EventArgs e)
        {
            if (panel.Visible == true)
            {
                panel.Visible = false;
            }
            else
            {
                panel.Visible = true;
            }
        }

        private void EmployeeAdd_Click(object sender, EventArgs e)
        {
            panel.Visible = false;
        }

        private void buttonRequirements_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Внимание! используйте только указанные символы. Пароль для регистрации в приложении должен содержать:\n \t 1. A-Z: хотя бы одну заглавную латинскую букву." +
             "\n\t 2. a-z: хотя бы одну строчную латинскую букву. \n\t 3. 4-15 символов \n\t 4. 0-9: одну или несколько цифр \n\t 5. !?@$#%_*=() минимум один спец символ");
        }

        private void buttonVisible_Click(object sender, EventArgs e)
        {
            buttonVisible.Visible = false;
            pictureVisible.Visible = true;
            textPassword.UseSystemPasswordChar = false;
        }

        private void pictureVisible_Click(object sender, EventArgs e)
        {
            buttonVisible.Visible = true;
            pictureVisible.Visible = false;
            textPassword.UseSystemPasswordChar = true;
        }

        private void textSeries_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8)
            {
                e.Handled = true;
            }
        }

        private void textNomer_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8)
            {
                e.Handled = true;
            }
        }

        private void phone_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8)
            {
                e.Handled = true;
            }
        }
    }
}
