﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class EmployeeUpd : Form
    {
        string id_employee;
        string id_passport;
        public static string[] udp_login = new string[1];
        DataBase dataBase = new DataBase();
        public EmployeeUpd(string id_employee, string surname, string name, string patronymic, string pol, string date_of_birth, string phone, string login, string role)
        {
            InitializeComponent();
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSet_Pol.Pol". При необходимости она может быть перемещена или удалена.
            this.polTableAdapter.Fill(this.pP_PigalevDataSet_Pol.Pol);
            string searchString = $"Select role From Role Where Not role = 'Администратор'";
            SqlCommand com = new SqlCommand(searchString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader read = com.ExecuteReader();
            while (read.Read())
            {
                textRole.Items.Add(read.GetString(0));
            }
            read.Close();
            this.surname.Text = surname;
            this.name.Text = name;
            this.patronymic.Text = patronymic;
            text_id_pol.Text = pol;
            this.date_of_birth.Text = date_of_birth;
            this.phone.Text = phone;
            text_login.Text = login;
            textRole.Text = role;
            SqlCommand sqlCommand_comments = new SqlCommand($"Select сomments From Employee Where id_employee = '{id_employee}'", dataBase.GetConnection());
            textComment.Text = sqlCommand_comments.ExecuteScalar().ToString();
            SqlCommand sqlCommand_passport = new SqlCommand($"Select id_passport From Employee Where id_employee = '{id_employee}'", dataBase.GetConnection());
            this.id_passport = sqlCommand_passport.ExecuteScalar().ToString();
            // Вывод паспотных данных
            SqlCommand sqlCommand_series = new SqlCommand($"Select series From PassportData Where id_passport = '{id_passport}'", dataBase.GetConnection());
            textSeries.Text = sqlCommand_series.ExecuteScalar().ToString();
            SqlCommand sqlCommand_number = new SqlCommand($"Select number From PassportData Where id_passport = '{id_passport}'", dataBase.GetConnection());
            textNomer.Text = sqlCommand_number.ExecuteScalar().ToString();
            SqlCommand sqlCommand_who_issued = new SqlCommand($"Select who_issued From PassportData Where id_passport = '{id_passport}'", dataBase.GetConnection());
            textWhoIssued.Text = sqlCommand_who_issued.ExecuteScalar().ToString();
            SqlCommand sqlCommand_date_issued = new SqlCommand($"Select date_issued From PassportData Where id_passport = '{id_passport}'", dataBase.GetConnection());
            textDateIssued.Text = sqlCommand_date_issued.ExecuteScalar().ToString();
            SqlCommand sqlCommand_registration = new SqlCommand($"Select registration From PassportData Where id_passport = '{id_passport}'", dataBase.GetConnection());
            textRegistration.Text = sqlCommand_registration.ExecuteScalar().ToString();
            //
            this.id_employee = id_employee;
            dataBase.closeConnection();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }
        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            Employee employee = new Employee();
            employee.ShowDialog();
        }

        private void EmployeeUpd_Click(object sender, EventArgs e)
        {
            panel.Visible = false;
        }

        private void textSeries_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8)
            {
                e.Handled = true;
            }
        }
        private void textNomer_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8)
            {
                e.Handled = true;
            }
        }

        private void phone_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8)
            {
                e.Handled = true;
            }
        }

        private void buttonChangePasswordAdmin_Click(object sender, EventArgs e) // Переход на форму редактирования пароля
        {
            this.Hide();
            PasswordChange_Admin passwordChange_Admin = new PasswordChange_Admin(id_employee, surname.Text, name.Text, patronymic.Text, text_id_pol.Text, date_of_birth.Text, phone.Text, text_login.Text, textRole.Text);
            passwordChange_Admin.ShowDialog();
        }

        private void button_save_Click(object sender, EventArgs e) // Применение внесённых изменений
        {
            panel.Visible = true;
            dataBase.openConnection();
            string sqccommand_pol = $"SELECT id_pol From Pol WHERE pol = '{text_id_pol.Text}'"; // Проверка, что пол выбран из списка
            SqlDataAdapter sda = new SqlDataAdapter(sqccommand_pol, dataBase.GetConnection());
            string sqccommand_role = $"SELECT id_role From Role WHERE role = '{textRole.Text}'"; // Проверка, что роль выбрана из списка
            SqlDataAdapter sda_role = new SqlDataAdapter(sqccommand_role, dataBase.GetConnection());
            DataTable dtbl = new DataTable();
            sda.Fill(dtbl);
            DataTable dtbl1 = new DataTable();
            sda_role.Fill(dtbl1);
            if (dtbl.Rows.Count == 0) MessageBox.Show("Поле пол должно быть выбрано из списка");
            else if (dtbl1.Rows.Count == 0) MessageBox.Show("Поле роль должно быть выбрано из списка");
            else if (surname.Text.Replace(" ", "") == "") MessageBox.Show("Поле фамилия не может быть пустым");
            else if (name.Text.Replace(" ", "") == "") MessageBox.Show("Поле имя не может быть пустым");
            else if (patronymic.Text.Replace(" ", "") == "") MessageBox.Show("Поле отчество не может быть пустым");
            else if (date_of_birth.Text.Replace(" ", "") == "") MessageBox.Show("Поле дата рождения не может быть пустым");
            else if (phone.Text.Replace(" ", "") == "") MessageBox.Show("Поле телефон не может быть пустым");
            else if (text_login.Text.Replace(" ", "") == "") MessageBox.Show("Поле логин не может быть пустым");
            else if (textSeries.Text.Replace(" ", "") == "") MessageBox.Show("Поле серия не может быть пустым");
            else if (textNomer.Text.Replace(" ", "") == "") MessageBox.Show("Поле номер не может быть пустым");
            else if (textWhoIssued.Text.Replace(" ", "") == "") MessageBox.Show("Поле кем выдано не может быть пустым");
            else if (textDateIssued.Text.Replace(" ", "") == "") MessageBox.Show("Поле дата выдачи не может быть пустым");
            else if (textRegistration.Text.Replace(" ", "") == "") MessageBox.Show("Поле прописка не может быть пустым");
            else if (textSeries.TextLength != 4) MessageBox.Show("Поле серия паспорта должно иметь 4 цифры");
            else if (textNomer.TextLength != 6) MessageBox.Show("Поле номер паспорта должно иметь 6 цифр");
            else
            {
                SqlCommand sqlCommand_log = new SqlCommand($"Select login From Employee Where id_employee = '{id_employee}'", dataBase.GetConnection()); // Проверка, что пользователя с таким логиным нет
                string login = sqlCommand_log.ExecuteScalar().ToString();
                string sqccommand_login = $"SELECT login From Employee WHERE login = '{text_login.Text}' and not login = '{login}'";
                SqlDataAdapter sda2 = new SqlDataAdapter(sqccommand_login, dataBase.GetConnection());
                DataTable dtbl2 = new DataTable();
                sda2.Fill(dtbl2);
                if (dtbl2.Rows.Count > 0)
                {
                    panel.Visible = false;
                    MessageBox.Show("Пользователь с таким логиным уже зарегистрирован");
                }
                else
                {
                    string sqccommand_passport = $"SELECT E.id_passport From PassportData P inner join Employee E ON E.id_passport = P.id_passport WHERE P.series = '{textSeries.Text}' and P.number = '{textNomer.Text}' and Not E.login = '{login}'";
                    SqlDataAdapter sda3 = new SqlDataAdapter(sqccommand_passport, dataBase.GetConnection()); // Проверка, что паспортных данных таких уже нет
                    DataTable dtbl3 = new DataTable();
                    sda3.Fill(dtbl3);
                    if (dtbl3.Rows.Count > 0)
                    {
                        panel.Visible = false;
                        MessageBox.Show("Пользователь с такими паспортными данными уже зарегистрирован в системе");
                    }
                    else
                    {
                        SqlCommand sqlCommand_pol = new SqlCommand(sqccommand_pol, dataBase.GetConnection());
                        var id_pol = sqlCommand_pol.ExecuteScalar().ToString();
                        SqlCommand sqlCommand_password = new SqlCommand($"Select id_passport From Employee Where id_employee = '{id_employee}'", dataBase.GetConnection());
                        string id_password = sqlCommand_password.ExecuteScalar().ToString();
                        var addQuery1 = $"update PassportData set series = '{textSeries.Text}', number = '{textNomer.Text}', who_issued = '{textWhoIssued.Text}', date_issued = '{Convert.ToDateTime(textDateIssued.Text)}', registration = '{textRegistration.Text}' where id_passport = '{id_passport}'";
                        var command1 = new SqlCommand(addQuery1, dataBase.GetConnection());
                        command1.ExecuteNonQuery();
                        SqlCommand sqlCommand_role = new SqlCommand(sqccommand_role, dataBase.GetConnection());
                        string id_role = sqlCommand_role.ExecuteScalar().ToString();
                        var addQuery = $"update Employee set surname = '{surname.Text}', name = '{name.Text}', patronymic = '{patronymic.Text}' , id_pol = '{id_pol}', id_passport = '{id_password}', id_role = '{id_role}', date_of_birth = '{Convert.ToDateTime(date_of_birth.Text)}', login = '{text_login.Text}', phone = '{phone.Text}', сomments = '{textComment.Text}' where id_employee = '{id_employee}'";
                        var command = new SqlCommand(addQuery, dataBase.GetConnection());
                        command.ExecuteNonQuery();
                        panel.Visible = false;
                        MessageBox.Show("Запись успешно изменена");
                        // Уввеличения массивов для вывода в Debug
                        udp_login[udp_login.Length-1] = text_login.Text;
                        Array.Resize(ref udp_login, udp_login.Length + 1);
                        //
                        this.Hide();
                        Employee employee = new Employee();
                        employee.ShowDialog();
                    }
                }
            }
            dataBase.closeConnection();
        }

        private void labelPassport_Click(object sender, EventArgs e)
        {
            if (panel.Visible == true)
            {
                panel.Visible = false;
            }
            else
            {
                panel.Visible = true;
            }
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            if (panel.Visible == true)
            {
                panel.Visible = false;
            }
            else
            {
                panel.Visible = true;
            }
        }
    }
}
