﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace IT_Rex
{
    public partial class MainMenu : Form // Главное окно
    {
        public static string role;
        DataBase dataBase = new DataBase();
        public MainMenu()
        {
            InitializeComponent();
            dataBase.openConnection();
            SqlCommand sqlCommand_role = new SqlCommand($"SELECT R.role From Employee E inner join Role R ON E.id_role = R.id_role WHERE E.login = '{Authorization.login}'", dataBase.GetConnection());
            string role = sqlCommand_role.ExecuteScalar().ToString(); // Вывод роли, под которой зашёл сотрудник
            if (role == "Администратор")
            {
                buttonEmployee.Visible = true;
                labelAddEmployee.Visible = true;
                buttonSalary.Visible = true;
                labelFooter.Text = labelFooter.Text + " Администратор";
            }
            else if (role == "Сотрудник")
            {
                labelFooter.Text = labelFooter.Text + " Сотрудник";
                buttonExit.Location = new Point(119, 393);
                buttonWork.Location = new Point(114, 105);
                label3.Location = new Point(132, 157);
            }
            else if (role == "Бухгалтер")
            {
                labelFooter.Text = labelFooter.Text + " Бухгалтер";
                buttonWork.Location = new Point(114, 105);
                label3.Location = new Point(132, 157);
                buttonSalary.Visible = true;
            }
            SqlCommand sqlCommand_surname = new SqlCommand($"SELECT surname From Employee WHERE login = '{Authorization.login}'", dataBase.GetConnection());
            string surname = sqlCommand_surname.ExecuteScalar().ToString();
            SqlCommand sqlCommand_name = new SqlCommand($"SELECT name From Employee WHERE login = '{Authorization.login}'", dataBase.GetConnection());
            string name = sqlCommand_name.ExecuteScalar().ToString();
            SqlCommand sqlCommand_patronymic = new SqlCommand($"SELECT patronymic From Employee WHERE login = '{Authorization.login}'", dataBase.GetConnection());
            string patronymic = sqlCommand_patronymic.ExecuteScalar().ToString();
            labelPersonalArea.Text = surname + " " + name[0] + "." + patronymic[0] + ".";
            dataBase.closeConnection();
        }

        private void labelPersonalArea_Click(object sender, EventArgs e)
        {
            this.Hide();
            PersonalArea personalArea = new PersonalArea();
            personalArea.ShowDialog();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }
        private void PersonalArea_Click(object sender, EventArgs e)
        {
            this.Hide();
            PersonalArea personalArea = new PersonalArea();
            personalArea.ShowDialog();
        }

        private void labelPersonalArea_MouseEnter(object sender, EventArgs e)
        {
            labelPersonalArea.ForeColor = Color.Black;
        }

        private void labelPersonalArea_MouseLeave(object sender, EventArgs e)
        {
            labelPersonalArea.ForeColor = Color.FromArgb(4,52,108);
        }

        private void label3_MouseEnter(object sender, EventArgs e)
        {
            label3.ForeColor = Color.Black;
        }

        private void label3_MouseLeave(object sender, EventArgs e)
        {
            label3.ForeColor = Color.FromArgb(4, 52, 108);
        }

        private void labelAddEmployee_MouseEnter(object sender, EventArgs e)
        {
            labelAddEmployee.ForeColor = Color.Black;
        }

        private void labelAddEmployee_MouseLeave(object sender, EventArgs e)
        {
            labelAddEmployee.ForeColor = Color.FromArgb(4, 52, 108);
        }

        private void label5_MouseEnter(object sender, EventArgs e)
        {
            label5.ForeColor = Color.Black;
        }

        private void label7_MouseEnter(object sender, EventArgs e)
        {
            label7.ForeColor = Color.Black;
        }

        private void label6_MouseEnter(object sender, EventArgs e)
        {
            label6.ForeColor = Color.Black;
        }

        private void label8_MouseEnter(object sender, EventArgs e)
        {
            label8.ForeColor = Color.Black;
        }

        private void label5_MouseLeave(object sender, EventArgs e)
        {
            label5.ForeColor = Color.FromArgb(4, 52, 108);
        }

        private void label7_MouseLeave(object sender, EventArgs e)
        {
            label7.ForeColor = Color.FromArgb(4, 52, 108);
        }

        private void label6_MouseLeave(object sender, EventArgs e)
        {
            label6.ForeColor = Color.FromArgb(4, 52, 108);
        }

        private void label8_MouseLeave(object sender, EventArgs e)
        {
            label8.ForeColor = Color.FromArgb(4, 52, 108);
        }

        private void buttonEmployee_Click(object sender, EventArgs e)
        {
            this.Hide();
            Employee employee = new Employee();
            employee.ShowDialog();
        }

        private void buttonExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            this.Hide();
            AboutCompany aboutCompany = new AboutCompany();
            aboutCompany.ShowDialog();
        }

        private void labelAddEmployee_Click(object sender, EventArgs e)
        {
            this.Hide();
            EmployeeAdd employeeAdd = new EmployeeAdd();
            employeeAdd.ShowDialog();
        }

        private void buttonContract_Click(object sender, EventArgs e)
        {
            this.Hide();
            Contract contract = new Contract();
            contract.ShowDialog();
        }

        private void label6_Click(object sender, EventArgs e)
        {
            this.Hide();
            ContractAdd contractAdd = new ContractAdd();
            contractAdd.ShowDialog();
        }

        private void buttonSupplier_Click(object sender, EventArgs e)
        {
            this.Hide();
            Supplier supplier = new Supplier();
            supplier.ShowDialog();
        }

        private void label8_Click(object sender, EventArgs e)
        {
            this.Hide();
            SupplierAdd supplierAdd = new SupplierAdd();
            supplierAdd.ShowDialog();
        }

        private void buttonProduct_Click(object sender, EventArgs e)
        {
            this.Hide();
            OrderUpplier orderUpplier = new OrderUpplier();
            orderUpplier.ShowDialog();
        }

        private void label7_Click(object sender, EventArgs e)
        {
            this.Hide();
            OrderUpplierAdd orderUpplierAdd = new OrderUpplierAdd();
            orderUpplierAdd.ShowDialog();
        }

        private void label5_Click(object sender, EventArgs e)
        {
            this.Hide();
            ClientAdd clientAdd = new ClientAdd();
            clientAdd.ShowDialog();
        }

        private void buttonClient_Click(object sender, EventArgs e)
        {
            this.Hide();
            Client client = new Client();
            client.ShowDialog();
        }

        private void buttonWork_Click(object sender, EventArgs e)
        {
            this.Hide();
            Work work = new Work();
            work.ShowDialog();
        }

        private void label3_Click(object sender, EventArgs e)
        {
            this.Hide();
            WorkAdd workAdd = new WorkAdd();
            workAdd.ShowDialog();
        }

        private void buttonSalary_Click(object sender, EventArgs e)
        {
            this.Hide();
            Salary salary = new Salary();
            salary.ShowDialog();
        }
    }
}
