﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class OrderUpplierAdd : Form // Форма добавления заказа поставщику
    {
        public static string[] add_product = new string[1];
        DataBase dataBase = new DataBase();
        public OrderUpplierAdd()
        {
            InitializeComponent();
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            OrderUpplier orderUpplier = new OrderUpplier();
            orderUpplier.ShowDialog();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button_save_Click(object sender, EventArgs e) // Сохрание в базе данных
        {
            string sqccommand_country = $"SELECT id_order_status From OrderStatus WHERE order_status = '{textStatus.Text}'"; // Проверка, что статус выбран из списка
            SqlDataAdapter sda_country = new SqlDataAdapter(sqccommand_country, dataBase.GetConnection());
            DataTable dtbl_country = new DataTable();
            sda_country.Fill(dtbl_country);
            if (dtbl_country.Rows.Count == 0) MessageBox.Show("Поле статус должно быть выбрано из списка");
            else
            {
                string sqccommand_edition = $"SELECT id_supplier From Suppliers WHERE name_organization = '{textSupplier.Text}'"; // Проверка, что поставщик выбран из списка
                SqlDataAdapter sda_edition = new SqlDataAdapter(sqccommand_edition, dataBase.GetConnection());
                DataTable dtbl_edition = new DataTable();
                sda_edition.Fill(dtbl_edition);
                if (dtbl_edition.Rows.Count == 0) MessageBox.Show("Поле поставщик должно быть выбрано из списка");
                else
                {
                    if (textName.Text.Replace(" ", "") == "") MessageBox.Show("Поле наименование не может быть пустым");
                    else if (textQuantity.Text.Replace(" ", "") == "0") MessageBox.Show("Поле количество не может быть равным '0'");
                    else if (textPrice.Text.Replace(" ", "") == "0") MessageBox.Show("Поле цена не может быть равным '0'");
                    else
                    {
                        dataBase.openConnection();
                        SqlCommand sqlCommand_order_status = new SqlCommand($"Select id_order_status From OrderStatus Where order_status = '{textStatus.Text}'", dataBase.GetConnection());
                        string id_order_status = sqlCommand_order_status.ExecuteScalar().ToString();
                        SqlCommand sqlCommand_suplier = new SqlCommand($"Select id_supplier From Suppliers Where name_organization = '{textSupplier.Text}'", dataBase.GetConnection());
                        string id_supplier = sqlCommand_suplier.ExecuteScalar().ToString();
                        var addQuery = $"insert into OrderUpplier (id_order_status, id_supplier, product, quantity, price, summa, comment) values ('{id_order_status}','{id_supplier}','{textName.Text}', '{textQuantity.Text}', cast('{textPrice.Text.Replace(',', '.')}' as float), cast('{textSumma.Text.Replace(',', '.')}' as float), '{textComment.Text}')";
                        var command = new SqlCommand(addQuery, dataBase.GetConnection());
                        command.ExecuteNonQuery();
                        MessageBox.Show("Запись успешно добавлена в таблицу");
                        // Уввеличения массивов для вывода в Debug
                        add_product[add_product.Length-1] = textName.Text;
                        Array.Resize(ref add_product, add_product.Length + 1);
                        // Очистка полей
                        textSupplier.Text = "";
                        textName.Text = "";
                        textQuantity.Text = "0";
                        textQuantity.ForeColor = Color.Gray;
                        textPrice.Text = "0";
                        textPrice.ForeColor = Color.Gray;
                        textSumma.Text = "0";
                        textComment.Text = "";
                        dataBase.closeConnection();
                    }
                }
            }
        }

        private void OrderUpplierAdd_Load(object sender, EventArgs e)
        {
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSetSupplier.Suppliers". При необходимости она может быть перемещена или удалена.
            this.suppliersTableAdapter.Fill(this.pP_PigalevDataSetSupplier.Suppliers);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSetOrderStatus.OrderStatus". При необходимости она может быть перемещена или удалена.
            this.orderStatusTableAdapter.Fill(this.pP_PigalevDataSetOrderStatus.OrderStatus);
            textQuantity.Text = "0";
            textQuantity.ForeColor = Color.Gray;
            textPrice.Text = "0";
            textPrice.ForeColor = Color.Gray;
        }

        private void textQuantity_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8) // цифры
            {
                e.Handled = true;
            }
        }
        private void textPrice_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8 && !(e.KeyChar == ',')) // цифры, клавиша BackSpace и ","
            {
                e.Handled = true;
            }
        }

        private void textQuantity_TextChanged(object sender, EventArgs e)
        {
            double kolvo = 0;
            if (textQuantity.Text != "")
            {
                kolvo = Convert.ToDouble(textQuantity.Text);
            }
            double price = 0;
            if (textPrice.Text != "")
            {
                price = Convert.ToDouble(textPrice.Text);
            }
            textSumma.Text = Convert.ToString(GetSumma(kolvo, price));
        }
        public static double GetSumma(double kolvo, double price) // Метод для подсчёта суммы
        {
            double summa = 0;
            summa = kolvo * price;
            return summa;
        }

        private void textPrice_TextChanged(object sender, EventArgs e)
        {
            if(textPrice.TextLength > 1)
            {
                string text = textPrice.Text.Substring(0, textPrice.Text.Length - 1);
                if (ContractAdd.GetCount(textPrice.Text) > 2)
                {
                    textPrice.Text = text;
                    textPrice.SelectionStart = textPrice.Text.Length;
                }
            }
            double kolvo = 0;
            if (textQuantity.Text != "")
            {
                kolvo = Convert.ToDouble(textQuantity.Text);
            }
            double price = 0;
            if (textPrice.Text != "")
            {
                price = Convert.ToDouble(textPrice.Text);
            }
            textSumma.Text = Convert.ToString(GetSumma(kolvo, price));
        }

        private void textPrice_Leave(object sender, EventArgs e)
        {
            if (textPrice.Text == "")
            {
                textPrice.Text = "0";
                textPrice.ForeColor = Color.Gray;
            }
        }

        private void textPrice_Enter(object sender, EventArgs e)
        {
            if (textPrice.ForeColor == Color.Gray)
            {
                textPrice.Text = null;
                textPrice.ForeColor = Color.Black;
            }
        }

        private void textQuantity_Enter(object sender, EventArgs e)
        {
            if (textQuantity.ForeColor == Color.Gray)
            {
                textQuantity.Text = null;
                textQuantity.ForeColor = Color.Black;
            }
        }

        private void textQuantity_Leave(object sender, EventArgs e)
        {
            if (textQuantity.Text == "")
            {
                textQuantity.Text = "0";
                textQuantity.ForeColor = Color.Gray;
            }
        }
    }
}
