﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace IT_Rex
{
    public partial class PassportData : Form // Форма редактирования паспортных данных
    {
        DataBase dataBase = new DataBase();
        public PassportData()
        {
            InitializeComponent();
            dataBase.openConnection();
            SqlCommand sqlCommand_series = new SqlCommand($"SELECT P.series From PassportData P inner join Employee E ON E.id_passport = P.id_passport WHERE E.login = '{Authorization.login}'", dataBase.GetConnection());
            textSeries.Text = sqlCommand_series.ExecuteScalar().ToString();
            SqlCommand sqlCommand_number = new SqlCommand($"SELECT P.number From PassportData P inner join Employee E ON E.id_passport = P.id_passport WHERE E.login = '{Authorization.login}'", dataBase.GetConnection());
            textNomer.Text = sqlCommand_number.ExecuteScalar().ToString();
            SqlCommand sqlCommand_who_issued = new SqlCommand($"SELECT P.who_issued From PassportData P inner join Employee E ON E.id_passport = P.id_passport WHERE E.login = '{Authorization.login}'", dataBase.GetConnection());
            textWhoIssued.Text = sqlCommand_who_issued.ExecuteScalar().ToString();
            SqlCommand sqlCommand_date_issued = new SqlCommand($"SELECT P.date_issued From PassportData P inner join Employee E ON E.id_passport = P.id_passport WHERE E.login = '{Authorization.login}'", dataBase.GetConnection());
            textDateIssued.Text = sqlCommand_date_issued.ExecuteScalar().ToString();
            SqlCommand sqlCommand_registration = new SqlCommand($"SELECT P.registration From PassportData P inner join Employee E ON E.id_passport = P.id_passport WHERE E.login = '{Authorization.login}'", dataBase.GetConnection());
            textRegistration.Text = sqlCommand_registration.ExecuteScalar().ToString();
            dataBase.closeConnection();
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            PersonalArea personalArea = new PersonalArea();
            personalArea.ShowDialog();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void textSeries_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8)
            {
                e.Handled = true;
            }
        }
        private void textNomer_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8)
            {
                e.Handled = true;
            }
        }

        private void button_save_Click(object sender, EventArgs e) // Принятие изменений
        {
            dataBase.openConnection();
            if (textSeries.Text.Replace(" ", "") == "") MessageBox.Show("Поле серия не может быть пустым");
            else if (textNomer.Text.Replace(" ", "") == "") MessageBox.Show("Поле номер не может быть пустым");
            else if (textWhoIssued.Text.Replace(" ", "") == "") MessageBox.Show("Поле кем выдано не может быть пустым");
            else if (textDateIssued.Text.Replace(" ", "") == "") MessageBox.Show("Поле дата выдачи не может быть пустым");
            else if (textRegistration.Text.Replace(" ", "") == "") MessageBox.Show("Поле прописка не может быть пустым");
            else if (textSeries.TextLength != 4) MessageBox.Show("Поле серия паспорта должно иметь 4 цифры");
            else if (textNomer.TextLength != 6) MessageBox.Show("Поле номер паспорта должно иметь 6 цифр");
            else
            {
                SqlCommand sqccommand_passport1 = new SqlCommand($"SELECT PD.series From Employee E inner join PassportData PD ON PD.id_passport = E.id_passport WHERE login = '{Authorization.login}'", dataBase.GetConnection());
                string passport_seria = sqccommand_passport1.ExecuteScalar().ToString();
                string sqccommand_passport = $"SELECT id_passport From PassportData WHERE series = '{textSeries.Text}' and series <> '{passport_seria}'"; // Проверка, что таких паспортных данных нет
                SqlDataAdapter sda3 = new SqlDataAdapter(sqccommand_passport, dataBase.GetConnection());
                DataTable dtbl3 = new DataTable();
                sda3.Fill(dtbl3);
                if (dtbl3.Rows.Count > 0)
                {
                    MessageBox.Show("Пользователь с такими паспортными данными уже зарегистрирован в системе");
                }
                else
                {
                    var confirmResult = MessageBox.Show("Вы точно хотите изменить личные данные?", "Подтвердите изменение!", MessageBoxButtons.YesNo);
                    if (confirmResult == DialogResult.Yes)
                    {
                        SqlCommand sqlCommand_id = new SqlCommand($"SELECT P.id_passport From PassportData P inner join Employee E ON E.id_passport = P.id_passport WHERE E.login = '{Authorization.login}'", dataBase.GetConnection());
                        string id_passport = sqlCommand_id.ExecuteScalar().ToString();
                        var addQuery = $"update PassportData set series = '{textSeries.Text}', number = '{textNomer.Text}', who_issued = '{textWhoIssued.Text}', date_issued = '{Convert.ToDateTime(textDateIssued.Text)}', registration = '{textRegistration.Text}' where id_passport = '{id_passport}'";
                        var command = new SqlCommand(addQuery, dataBase.GetConnection());
                        command.ExecuteNonQuery();
                        MessageBox.Show("Личные данные изменены");
                        dataBase.closeConnection();
                    }
                }
            }
        }
    }
}
