﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class PasswordChange_Admin : Form // Форма изменения пароля администратором
    {
        string id_employee;
        string surname;
        string name;
        string patronymic;
        string pol;
        string date_of_birth;
        string phone;
        string login;
        string role;
        DataBase dataBase = new DataBase();
        Regex rg = new Regex("^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d)(?=.*[^\\da-zA-Z]).{8,15}$");
        public PasswordChange_Admin(string id_employee, string surname, string name, string patronymic, string pol, string date_of_birth, string phone, string login, string role)
        {
            InitializeComponent();
            this.id_employee = id_employee;
            this.surname = surname;
            this.name = name;
            this.patronymic = patronymic;
            this.pol = pol;
            this.date_of_birth = date_of_birth;
            this.phone = phone;
            this.login = login;
            this.role = role;
        }

        private void buttonRequirements_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Внимание! используйте только указанные символы. Пароль для регистрации в приложении должен содержать:\n \t 1. A-Z: хотя бы одну заглавную латинскую букву." +
             "\n\t 2. a-z: хотя бы одну строчную латинскую букву. \n\t 3. 4-15 символов \n\t 4. 0-9: одну или несколько цифр \n\t 5. !?@$#%_*=() минимум один спец символ");
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }


        private void pictureVisible1_Click(object sender, EventArgs e)
        {
            buttonVisible1.Visible = true;
            pictureVisible1.Visible = false;
            text_password1.UseSystemPasswordChar = true;
        }

        private void buttonVisible1_Click(object sender, EventArgs e)
        {
            buttonVisible1.Visible = false;
            pictureVisible1.Visible = true;
            text_password1.UseSystemPasswordChar = false;
        }

        private void buttonVisible2_Click(object sender, EventArgs e)
        {
            buttonVisible2.Visible = false;
            pictureVisible2.Visible = true;
            text_password2.UseSystemPasswordChar = false;
        }

        private void pictureVisible2_Click(object sender, EventArgs e)
        {
            buttonVisible2.Visible = true;
            pictureVisible2.Visible = false;
            text_password2.UseSystemPasswordChar = true;
        }

        private void pictureVisible3_Click(object sender, EventArgs e)
        {
            buttonVisible3.Visible = true;
            pictureVisible3.Visible = false;
            text_password3.UseSystemPasswordChar = true;
        }

        private void buttonVisible3_Click(object sender, EventArgs e)
        {
            buttonVisible3.Visible = false;
            pictureVisible3.Visible = true;
            text_password3.UseSystemPasswordChar = false;
        }

        private void button_save_Click(object sender, EventArgs e) // Принятие нового пароля
        {
            dataBase.openConnection();
            SqlCommand sqlCommand_password = new SqlCommand($"SELECT password From Employee WHERE login = '{Authorization.login}'", dataBase.GetConnection()); // Взятие информацию о пароле пользователя под которым произведён вход
            Regex rg = new Regex("^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d)(?=.*[^\\da-zA-Z]).{4,15}$"); // Созданное регулярное выражение
            string pass = text_password2.Text;
            string password = sqlCommand_password.ExecuteScalar().ToString();
            Shifr.phraze = text_password1.Text;
            Shifr myTeloInfo = new Shifr();
            myTeloInfo.ShifrCode();
            string password_1 = "";
            for (int i = 0; i < Shifr.codePhraze.Length; i++) // Шифрование введённого пароля для подтверждения пользователя
            {
                password_1 = password_1 + " " + Shifr.codePhraze[i];
            }
            if (text_password1.Text.Replace(" ", "") == "") MessageBox.Show("Не введён старый пароль");
            else if (text_password2.Text.Replace(" ", "") == "") MessageBox.Show("Новый пароль не введён");
            else if (text_password3.Text.Replace(" ", "") == "") MessageBox.Show("Новый пароль не потверждён");
            else if (password != password_1) MessageBox.Show("Старый пароль не верный");
            else if (text_password2.Text == text_password3.Text)
                if (rg.IsMatch(pass))
                {
                    var confirmResult = MessageBox.Show("Вы точно хотите изменить пароль?", "Подтвердите изменение!", MessageBoxButtons.YesNo);
                    if (confirmResult == DialogResult.Yes)
                    {
                        dataBase.openConnection();
                        Shifr.phraze = text_password2.Text;
                        Shifr myTeloInfo1 = new Shifr();
                        myTeloInfo1.ShifrCode();
                        string password_2 = "";
                        for (int i = 0; i < Shifr.codePhraze.Length; i++) // Шифрование нового пароля
                        {
                            password_2 = password_2 + " " + Shifr.codePhraze[i];
                        }
                        var addQuery = $"update Employee set password = '{password_2}' where login = '{login}'";
                        var command = new SqlCommand(addQuery, dataBase.GetConnection());
                        command.ExecuteNonQuery();
                        MessageBox.Show("Пароль успешно изменён");
                        dataBase.closeConnection();
                        this.Hide();
                        EmployeeUpd employeeUpd = new EmployeeUpd(id_employee, surname, name, patronymic, pol, date_of_birth, phone, login, role);
                        employeeUpd.ShowDialog();
                    }
                }
                else
                {
                    MessageBox.Show("Пароль не соответствует требованиям");
                }
            else
            {
                MessageBox.Show("Пароли не совпадают!!!");
            }
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            EmployeeUpd employeeUpd = new EmployeeUpd(id_employee, surname, name, patronymic, pol, date_of_birth, phone, login, role);
            employeeUpd.ShowDialog();
        }
    }
}
