﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class PersonalArea : Form // Форма личного кабинета
    {
        DataBase dataBase = new DataBase();
        public PersonalArea()
        {
            InitializeComponent();
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSet_Pol.Pol". При необходимости она может быть перемещена или удалена.
            this.polTableAdapter.Fill(this.pP_PigalevDataSet_Pol.Pol);
            dataBase.openConnection();
            SqlCommand sqlCommand_surname = new SqlCommand($"SELECT surname From Employee WHERE login = '{Authorization.login}'", dataBase.GetConnection());
            surname.Text = sqlCommand_surname.ExecuteScalar().ToString();
            SqlCommand sqlCommand_name = new SqlCommand($"SELECT name From Employee WHERE login = '{Authorization.login}'", dataBase.GetConnection());
            name.Text = sqlCommand_name.ExecuteScalar().ToString();
            SqlCommand sqlCommand_patronymic = new SqlCommand($"SELECT patronymic From Employee WHERE login = '{Authorization.login}'", dataBase.GetConnection());
            patronymic.Text = sqlCommand_patronymic.ExecuteScalar().ToString();
            SqlCommand sqlCommand_pol = new SqlCommand($"SELECT P.pol From Employee E inner join Pol P ON E.id_pol=P.id_pol WHERE E.login = '{Authorization.login}'", dataBase.GetConnection());
            text_id_pol.Text = sqlCommand_pol.ExecuteScalar().ToString();
            SqlCommand sqlCommand_date_of_birth = new SqlCommand($"SELECT date_of_birth From Employee WHERE login = '{Authorization.login}'", dataBase.GetConnection());
            date_of_birth.Text = sqlCommand_date_of_birth.ExecuteScalar().ToString();
            SqlCommand sqlCommand_phone = new SqlCommand($"SELECT phone From Employee WHERE login = '{Authorization.login}'", dataBase.GetConnection());
            if(sqlCommand_phone.ExecuteScalar().ToString() != null)
            {
                phone.Text = sqlCommand_phone.ExecuteScalar().ToString();
            }
            text_login.Text = Authorization.login;
            SqlCommand sqlCommand_comments = new SqlCommand($"SELECT сomments From Employee WHERE login = '{Authorization.login}'", dataBase.GetConnection());
            textBox1.Text = sqlCommand_comments.ExecuteScalar().ToString();
            dataBase.closeConnection();
        }

        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            MainMenu mainMenu = new MainMenu();
            mainMenu.ShowDialog();
        }

        private void button_save_Click(object sender, EventArgs e) // Добавление записи в БД
        {
            string sqccommand_pol = $"SELECT id_pol From Pol WHERE pol = '{text_id_pol.Text}'"; // проверка, что пол выбран из списка
            SqlDataAdapter sda = new SqlDataAdapter(sqccommand_pol, dataBase.GetConnection());
            DataTable dtbl = new DataTable();
            sda.Fill(dtbl);
            if (dtbl.Rows.Count == 0)
            {
                MessageBox.Show("Поле пол должно быть выбрано из списка");
            }
            else
            {
                string sqccommand_login = $"SELECT login From Employee WHERE login = '{text_login.Text}' and login <> '{Authorization.login}'"; // проверка логина
                SqlDataAdapter sda1 = new SqlDataAdapter(sqccommand_login, dataBase.GetConnection());
                DataTable dtbl1 = new DataTable();
                sda1.Fill(dtbl1);
                if (dtbl1.Rows.Count > 0)
                {
                    MessageBox.Show("Пользователь с таким логиным уже зарегистрирован");
                }
                else if (text_login.Text.Replace(" ", "") == "") MessageBox.Show("Поле логина не может быть пустым");
                else if (surname.Text.Replace(" ", "") == "") MessageBox.Show("Поле фамилия не может быть пустым");
                else if (name.Text.Replace(" ", "") == "") MessageBox.Show("Поле имя не может быть пустым");
                else if (patronymic.Text.Replace(" ", "") == "") MessageBox.Show("Поле отчество не может быть пустым");
                else if (date_of_birth.Text.Replace(" ", "") == "") MessageBox.Show("Поле дата рождения не может быть пустым");
                else
                {
                    var confirmResult = MessageBox.Show("Вы точно хотите изменить личные данные?", "Подтвердите изменение!", MessageBoxButtons.YesNo);
                    if (confirmResult == DialogResult.Yes)
                    {
                        dataBase.openConnection();
                        string id_pol;
                        SqlCommand sqlCommand_pol = new SqlCommand(sqccommand_pol, dataBase.GetConnection());
                        id_pol = sqlCommand_pol.ExecuteScalar().ToString();
                        var addQuery = $"update Employee set surname = '{surname.Text}', name = '{name.Text}', patronymic = '{patronymic.Text}', id_pol = '{id_pol}', date_of_birth = '{Convert.ToDateTime(date_of_birth.Text)}', phone = '{phone.Text}', login = '{text_login.Text}', сomments = '{textBox1.Text}' where login = '{Authorization.login}'";
                        var command = new SqlCommand(addQuery, dataBase.GetConnection());
                        command.ExecuteNonQuery();
                        MessageBox.Show("Личные данные изменены");
                        Authorization.login = text_login.Text;
                        dataBase.closeConnection();
                    }
                }
            }
        }

        private void button_change_password_Click(object sender, EventArgs e)
        {
            this.Hide();
            PasswordChange passwordChange = new PasswordChange();
            passwordChange.ShowDialog();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Hide();
            PassportData passportData = new PassportData();
            passportData.ShowDialog();
        }
    }
}
