﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace IT_Rex
{
    public partial class SupplierAdd : Form // Форма добавления поставщика
    {
        public static string[] add_supplier = new string[1];
        DataBase dataBase = new DataBase();
        public SupplierAdd()
        {
            InitializeComponent();
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            Supplier supplier = new Supplier();
            supplier.ShowDialog();
        }

        private void button_save_Click(object sender, EventArgs e) // Добавление данных в БД
        {
            if(textName.Text.Replace(" ", "") == "") MessageBox.Show("Поле название организации не может быть пустым");
            else if (textAddress.Text.Replace(" ", "") == "") MessageBox.Show("Поле адресс не может быть пустым");
            else if(textEmail.Text != "" && textEmail.Text.IndexOf('@') == -1) MessageBox.Show("Поле email должно содержать символ '@'");
            else
            {
                dataBase.openConnection();
                var addQuery = $"insert into Suppliers (name_organization, phone, email, address, сomment) values ('{textName.Text}','{textPhone.Text}','{textEmail.Text}','{textAddress.Text}', '{textComments.Text}')";
                var command = new SqlCommand(addQuery, dataBase.GetConnection());
                command.ExecuteNonQuery();
                MessageBox.Show("Запись успешно добавлена в таблицу");
                // Уввеличения массивов для вывода в Debug
                add_supplier[add_supplier.Length-1] = textName.Text;
                Array.Resize(ref add_supplier, add_supplier.Length + 1);
                // Очитка полей
                textName.Text = "";
                textPhone.Text = "";
                textEmail.Text = "";
                textAddress.Text = "";
                textComments.Text = "";
                dataBase.closeConnection();
            }
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void textPhone_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8)
            {
                e.Handled = true;
            }
        }
    }
}
