﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace IT_Rex
{
    public partial class SupplierUpd : Form // Форма изменения поставщика
    {
        string id_supplier;
        public static string[] upd_supplier = new string[1];
        DataBase dataBase = new DataBase();
        public SupplierUpd(string id_supplier, string name_organization, string phone, string email, string address)
        {
            InitializeComponent();
            textName.Text = name_organization;
            textPhone.Text = phone;
            textEmail.Text = email;
            textAddress.Text = address;
            dataBase.openConnection();
            SqlCommand sqlCommand_comment = new SqlCommand($"Select сomment From Suppliers Where id_supplier = '{id_supplier}'", dataBase.GetConnection());
            textComments.Text = sqlCommand_comment.ExecuteScalar().ToString();
            dataBase.closeConnection();
            this.id_supplier = id_supplier;
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            Supplier supplier = new Supplier();
            supplier.ShowDialog();
        }

        private void button_save_Click(object sender, EventArgs e) // Принятие измений
        {
            if (textName.Text.Replace(" ", "") == "") MessageBox.Show("Поле название организации не может быть пустым");
            else if (textAddress.Text.Replace(" ", "") == "") MessageBox.Show("Поле адресс не может быть пустым");
            else if (textEmail.Text != "" && textEmail.Text.IndexOf('@') == -1) MessageBox.Show("Поле email должно содержать символ '@'");
            else
            {
                dataBase.openConnection();
                var addQuery = $"update Suppliers set name_organization = '{textName.Text}', phone = '{textPhone.Text}', email = '{textEmail.Text}', address = '{textAddress.Text}', сomment = '{textComments.Text}' where id_supplier = '{id_supplier}'";
                var command = new SqlCommand(addQuery, dataBase.GetConnection());
                command.ExecuteNonQuery();
                MessageBox.Show("Запись успешно изменена");
                // Уввеличения массивов для вывода в Debug
                upd_supplier[upd_supplier.Length-1] = textName.Text;
                Array.Resize(ref upd_supplier, upd_supplier.Length + 1);
                // Переход на список
                this.Hide();
                Supplier supplier = new Supplier();
                supplier.ShowDialog();
                dataBase.closeConnection();
            }
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void textPhone_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8)
            {
                e.Handled = true;
            }
        }
    }
}