﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IT_Rex
{
    public partial class WorkUpd : Form // Форма изменения задания на работу
    {
        double discount = 0;
        double personalDiscount = 0;
        string id_work;
        public static string[] upd_work = new string[1];
        DataBase dataBase = new DataBase();
        public WorkUpd(string id_work, string condition, string employee, string data_start, string client, string type_work)
        {
            InitializeComponent();
            dataBase.openConnection();
            // Создание перечисления продукции
            string searchString = $"Select OU.product From OrderUpplier OU left join Work W ON OU.id_order_upplier = W.id_order_upplier where W.id_order_upplier IS NULL";
            SqlCommand com = new SqlCommand(searchString, dataBase.GetConnection());
            SqlDataReader read = com.ExecuteReader();
            while (read.Read())
            {
                textOrder_upplier.Items.Add(read.GetString(0));
            }
            read.Close();
            //
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSetClient.Client". При необходимости она может быть перемещена или удалена.
            this.clientTableAdapter.Fill(this.pP_PigalevDataSetClient.Client);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSetType_work.Type_work". При необходимости она может быть перемещена или удалена.
            this.type_workTableAdapter.Fill(this.pP_PigalevDataSetType_work.Type_work);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSetCondition.Condition". При необходимости она может быть перемещена или удалена.
            this.conditionTableAdapter.Fill(this.pP_PigalevDataSetCondition.Condition);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "pP_PigalevDataSetEmployee.Employee". При необходимости она может быть перемещена или удалена.
            this.employeeTableAdapter.Fill(this.pP_PigalevDataSetEmployee.Employee);
            // Вывод данных по заданию
            textEmployee.Text = employee;
            textcondition.Text = condition;
            textData_start.Text = data_start;
            SqlCommand sqlCommand_data_end = new SqlCommand($"Select data_end From Work Where id_work = '{id_work}'", dataBase.GetConnection());
            textData_end.Text = sqlCommand_data_end.ExecuteScalar().ToString();
            SqlCommand sqlCommand_duration = new SqlCommand($"Select duration From Work Where id_work = '{id_work}'", dataBase.GetConnection());
            textDuration.Text = sqlCommand_duration.ExecuteScalar().ToString();
            SqlCommand sqlCommand_complexity = new SqlCommand($"Select complexity From Work Where id_work = '{id_work}'", dataBase.GetConnection());
            textComplexity.Text = sqlCommand_complexity.ExecuteScalar().ToString();
            textType_work.Text = type_work;
            textClient.Text = client;
            if (textType_work.Text == "Установка оборудования")
            {
                textOrder_upplier.Visible = true;
                labelOrder_upplier.Visible = true;
                SqlCommand sqlCommand_OrderUpplier = new SqlCommand($"Select O.product From Work W inner join OrderUpplier O ON W.id_order_upplier = O.id_order_upplier Where W.id_work = '{id_work}'", dataBase.GetConnection());
                textOrder_upplier.Items.Add(sqlCommand_OrderUpplier.ExecuteScalar().ToString());
                textOrder_upplier.Text = sqlCommand_OrderUpplier.ExecuteScalar().ToString();
            }
            SqlCommand sqlCommand_price = new SqlCommand($"Select price From Work Where id_work = '{id_work}'", dataBase.GetConnection());
            textPrice.Text = sqlCommand_price.ExecuteScalar().ToString();
            SqlCommand sqlCommand_personal_discount = new SqlCommand($"Select personalDiscount From Work Where id_work = '{id_work}'", dataBase.GetConnection());
            personalDiscount = Convert.ToDouble(sqlCommand_personal_discount.ExecuteScalar().ToString());
            SqlCommand sqlCommand_summaDiscount = new SqlCommand($"Select summa From Work Where id_work = '{id_work}'", dataBase.GetConnection());
            textSummaDiscount.Text = sqlCommand_summaDiscount.ExecuteScalar().ToString();
            if (personalDiscount != 0)
            {
                label.Visible = false;
                textPersonalDiscount.Visible = false;
                buttonPersonalDiscount.Visible = false;
                buttonDeletePersonalDiscount.Visible = true;
                labelPersonalDiscount.Text = $"Применена персональная скидка {personalDiscount}%";
            }
            SqlCommand sqlCommand_сomments = new SqlCommand($"Select сomments From Work Where id_work = '{id_work}'", dataBase.GetConnection());
            textComment.Text = sqlCommand_сomments.ExecuteScalar().ToString();
            this.id_work = id_work;
            dataBase.closeConnection();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }
        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            Work work = new Work();
            work.ShowDialog();
        }

        private void button_save_Click(object sender, EventArgs e) // Сохранение данных
        {
            string sqccommand_employee = $"SELECT id_employee From Employee WHERE surname = '{textEmployee.Text}'"; // Проверка, что поставщик должен быть выбран из списка
            SqlDataAdapter sda_employee = new SqlDataAdapter(sqccommand_employee, dataBase.GetConnection());
            DataTable dtbl_employee = new DataTable();
            sda_employee.Fill(dtbl_employee);
            if (dtbl_employee.Rows.Count == 0) MessageBox.Show("Поле исполнитель должно быть выбрано из списка");
            else
            {
                string sqccommand_condition = $"SELECT id_condition From Condition WHERE condition = '{textcondition.Text}'"; // Проверка, что состояние должно быть выбрано из списка
                SqlDataAdapter sda_condition = new SqlDataAdapter(sqccommand_condition, dataBase.GetConnection());
                DataTable dtbl_condition = new DataTable();
                sda_condition.Fill(dtbl_condition);
                if (dtbl_condition.Rows.Count == 0) MessageBox.Show("Поле состояние должно быть выбрано из списка");
                else
                {
                    string sqccommand_type_work = $"SELECT id_type_work From Type_work WHERE type_work = '{textType_work.Text}'"; // Проверка, что тип работы должен быть выбран из списка
                    SqlDataAdapter sda_type_work = new SqlDataAdapter(sqccommand_type_work, dataBase.GetConnection());
                    DataTable dtbl_type_work = new DataTable();
                    sda_type_work.Fill(dtbl_type_work);
                    if (dtbl_type_work.Rows.Count == 0) MessageBox.Show("Поле вид работы должно быть выбрано из списка");
                    else
                    {
                        string sqccommand_client = $"SELECT id_client From Client WHERE name_organization = '{textClient.Text}'"; // Проверка, что клиент должен быть выбран из списка
                        SqlDataAdapter sda_client = new SqlDataAdapter(sqccommand_client, dataBase.GetConnection());
                        DataTable dtbl_client = new DataTable();
                        sda_client.Fill(dtbl_client);
                        if (dtbl_client.Rows.Count == 0) MessageBox.Show("Поле заказчик должно быть выбрано из списка");
                        else
                        {
                            string sqccommand_OrderUpplier = $"SELECT id_order_upplier From OrderUpplier WHERE product = '{textOrder_upplier.Text}'"; // Проверка, что заказ поставщику должен быть выбран из списка
                            SqlDataAdapter sda_OrderUpplier = new SqlDataAdapter(sqccommand_OrderUpplier, dataBase.GetConnection());
                            DataTable dtbl_OrderUpplier = new DataTable();
                            sda_OrderUpplier.Fill(dtbl_OrderUpplier);
                            if (dtbl_OrderUpplier.Rows.Count == 0 && textOrder_upplier.Text != "") MessageBox.Show("Поле товар должно быть выбрано из списка");
                            else
                            {
                                if (textDuration.Text.Replace(" ", "") == "") MessageBox.Show("Поле продолжительность не может быть пустым");
                                else if (textComplexity.Text.Replace(" ", "") == "") MessageBox.Show("Поле трудоёмкость не может быть пустым");
                                else
                                {
                                    dataBase.openConnection();
                                    // Проверка доступных часов указанных по договору
                                    if (labelDiscount.Text != "Клиент не имеет договора")
                                    {
                                        SqlCommand sqlCommand_count_hours = new SqlCommand($"Select c.count_hours - sum(w.complexity) From Work w inner join Client cl ON w.id_client = cl.id_client inner join Contract c ON cl.id_contract = c.id_contract where cl.name_organization = '{textClient.Text}' and w.id_work != '{id_work}' and month(w.data_start) = month('{DateTime.Today}')  Group by c.count_hours", dataBase.GetConnection());
                                        double a;
                                        if (sqlCommand_count_hours.ExecuteScalar() == null)
                                        {
                                            SqlCommand sqlCommand_count_hours1 = new SqlCommand($"Select c.count_hours From Client cl  inner join Contract c ON cl.id_contract = c.id_contract where cl.name_organization = '{textClient.Text}'", dataBase.GetConnection());
                                            a = Convert.ToDouble(sqlCommand_count_hours1.ExecuteScalar().ToString());
                                        }
                                        else
                                        {
                                            a = Convert.ToDouble(sqlCommand_count_hours.ExecuteScalar().ToString());
                                        }
                                        if (a < Convert.ToDouble(textComplexity.Text))
                                        {
                                            MessageBox.Show("Трудоёмкость больше чем указано в договоре");
                                            return;
                                        }
                                    }
                                    SqlCommand sqlCommand_id_employee = new SqlCommand(sqccommand_employee, dataBase.GetConnection());
                                    string id_employee = sqlCommand_id_employee.ExecuteScalar().ToString();
                                    SqlCommand sqlCommand_id_condition = new SqlCommand(sqccommand_condition, dataBase.GetConnection());
                                    string id_condition = sqlCommand_id_condition.ExecuteScalar().ToString();
                                    SqlCommand sqlCommand_id_type_work = new SqlCommand(sqccommand_type_work, dataBase.GetConnection());
                                    string id_type_work = sqlCommand_id_type_work.ExecuteScalar().ToString();
                                    SqlCommand sqlCommand_id_client = new SqlCommand(sqccommand_client, dataBase.GetConnection());
                                    string id_client = sqlCommand_id_client.ExecuteScalar().ToString();
                                    if (textOrder_upplier.Text != "") // Если вид работы Сопровождение ПО
                                    {
                                        SqlCommand sqlCommand_id_order_upplier = new SqlCommand(sqccommand_OrderUpplier, dataBase.GetConnection());
                                        string id_order_upplier = sqlCommand_id_order_upplier.ExecuteScalar().ToString();
                                        var addQuery = $"update Work SET id_condition = {id_condition}, id_employee = {id_employee}, data_start = '{Convert.ToDateTime(textData_start.Text)}', data_end = '{Convert.ToDateTime(textData_end.Text)}', duration = cast('{textDuration.Text.Replace(',', '.')}' as float), complexity = cast('{textComplexity.Text.Replace(',', '.')}' as float), id_client = '{id_client}', id_order_upplier = '{id_order_upplier}', id_type_work = '{id_type_work}', price = cast('{textPrice.Text.Replace(',', '.')}' as float), summa = cast('{textSummaDiscount.Text.Replace(',', '.')}' as float), сomments = '{textComment.Text}', personalDiscount = cast('{Convert.ToString(personalDiscount).Replace(',', '.')}' as float) Where id_work = '{id_work}'";
                                        var command = new SqlCommand(addQuery, dataBase.GetConnection());
                                        command.ExecuteNonQuery();
                                    }
                                    else // Если вид работы Установка оборудования
                                    {
                                        var addQuery = $"update Work SET id_condition = {id_condition}, id_employee = {id_employee}, data_start = '{Convert.ToDateTime(textData_start.Text)}', data_end = '{Convert.ToDateTime(textData_end.Text)}', duration = cast('{textDuration.Text.Replace(',', '.')}' as float), complexity = cast('{textComplexity.Text.Replace(',', '.')}' as float), id_client = '{id_client}', id_type_work = '{id_type_work}', price = cast('{textPrice.Text.Replace(',', '.')}' as float), summa = cast('{textSummaDiscount.Text.Replace(',', '.')}' as float), сomments = '{textComment.Text}', personalDiscount = cast('{Convert.ToString(personalDiscount).Replace(',', '.')}' as float) Where id_work = '{id_work}'";
                                        var command = new SqlCommand(addQuery, dataBase.GetConnection());
                                        command.ExecuteNonQuery();
                                    }
                                    MessageBox.Show("Запись успешно изменена");
                                    // Уввеличения массивов для вывода в Debug
                                    upd_work[upd_work.Length-1] = textClient.Text;
                                    Array.Resize(ref upd_work, upd_work.Length + 1);
                                    //
                                    this.Hide();
                                    Work work = new Work();
                                    work.ShowDialog();
                                    dataBase.closeConnection();
                                }
                            }
                        }
                    }
                }
            }
        }

        private void textDuration_KeyPress(object sender, KeyPressEventArgs e)
        {
            char number = e.KeyChar;
            if (!Char.IsDigit(number) && number != 8 && !(e.KeyChar == ',')) // цифры, клавиша BackSpace и ","
            {
                e.Handled = true;
            }
        }
        private void textDuration_Enter(object sender, EventArgs e)
        {
            if (textDuration.ForeColor == Color.Gray)
            {
                textDuration.Text = null;
                textDuration.ForeColor = Color.Black;
            }
        }

        private void textDuration_Leave(object sender, EventArgs e)
        {
            if (textDuration.Text == "")
            {
                textDuration.Text = "0";
                textDuration.ForeColor = Color.Gray;
            }
        }

        private void textComplexity_Enter(object sender, EventArgs e)
        {
            if (textComplexity.ForeColor == Color.Gray)
            {
                textComplexity.Text = null;
                textComplexity.ForeColor = Color.Black;
            }
        }

        private void textComplexity_Leave(object sender, EventArgs e)
        {
            if (textComplexity.Text == "")
            {
                textComplexity.Text = "0";
                textComplexity.ForeColor = Color.Gray;
            }
        }
        private void textPrice_Enter(object sender, EventArgs e)
        {
            if (textPrice.ForeColor == Color.Gray)
            {
                textPrice.Text = null;
                textPrice.ForeColor = Color.Black;
            }
        }

        private void textPrice_Leave(object sender, EventArgs e)
        {
            if (textPrice.Text == "")
            {
                textPrice.Text = "0";
                textPrice.ForeColor = Color.Gray;
            }
        }
        private void textPrice_TextChanged(object sender, EventArgs e)
        {
            if (textPrice.TextLength > 1)
            {
                string text = textPrice.Text.Substring(0, textPrice.Text.Length - 1);
                if (ContractAdd.GetCount(textPrice.Text) > 2)
                {
                    textPrice.Text = text;
                    textPrice.SelectionStart = textPrice.Text.Length;
                }
            }
            double kolvo = 0;
            if (textComplexity.Text != "")
            {
                kolvo = Convert.ToDouble(textComplexity.Text);
            }
            double price = 0;
            if (textPrice.Text != "")
            {
                price = Convert.ToDouble(textPrice.Text);
            }
            textSumma.Text = Convert.ToString(OrderUpplierAdd.GetSumma(kolvo, price));
        }

        private void textDuration_TextChanged(object sender, EventArgs e)
        {
            if (textDuration.TextLength > 1)
            {
                string text = textDuration.Text.Substring(0, textDuration.Text.Length - 1);
                if (ContractAdd.GetCount(textDuration.Text) > 2)
                {
                    textDuration.Text = text;
                    textDuration.SelectionStart = textDuration.Text.Length;
                }
            }
        }

        private void textComplexity_TextChanged(object sender, EventArgs e)
        {
            if (textComplexity.TextLength > 1)
            {
                string text = textComplexity.Text.Substring(0, textComplexity.Text.Length - 1);
                if (ContractAdd.GetCount(textComplexity.Text) > 2)
                {
                    textComplexity.Text = text;
                    textComplexity.SelectionStart = textComplexity.Text.Length;
                }
            }
            double kolvo = 0;
            if (textComplexity.Text != "")
            {
                kolvo = Convert.ToDouble(textComplexity.Text);
            }
            double price = 0;
            if (textPrice.Text != "")
            {
                price = Convert.ToDouble(textPrice.Text);
            }
            textSumma.Text = Convert.ToString(OrderUpplierAdd.GetSumma(kolvo, price));
        }

        private void textType_work_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (textType_work.Text == "Установка оборудования")
            {
                textOrder_upplier.Visible = true;
                labelOrder_upplier.Visible = true;
            }
            else
            {
                textOrder_upplier.Visible = false;
                labelOrder_upplier.Visible = false;
            }
        }

        private void buttonDeletePersonalDiscount_Click(object sender, EventArgs e)
        {
            personalDiscount = 0;
            textSummaDiscount.Text = Convert.ToString(WorkAdd.GetDiscount(Convert.ToDouble(textSumma.Text), Convert.ToDouble(discount + personalDiscount)));
            label.Visible = true;
            textPersonalDiscount.Visible = true;
            buttonPersonalDiscount.Visible = true;
            buttonDeletePersonalDiscount.Visible = false;
            labelPersonalDiscount.Text = "";
        }

        private void buttonPersonalDiscount_Click(object sender, EventArgs e)
        {
            if (Convert.ToDouble(textPersonalDiscount.Text) > 100 - discount)
            {
                MessageBox.Show("Скидка не может быть больше 100%");
            }
            else
            {
                personalDiscount = Convert.ToDouble(textPersonalDiscount.Text);
                textSummaDiscount.Text = Convert.ToString(WorkAdd.GetDiscount(Convert.ToDouble(textSumma.Text), Convert.ToDouble(discount + personalDiscount)));
                labelPersonalDiscount.Text = $"Применена персональная скидка {personalDiscount}%";
                label.Visible = false;
                textPersonalDiscount.Visible = false;
                buttonPersonalDiscount.Visible = false;
                buttonDeletePersonalDiscount.Visible = true;
            }
        }

        private void textPersonalDiscount_Enter(object sender, EventArgs e)
        {
            if (textPersonalDiscount.ForeColor == Color.Gray)
            {
                textPersonalDiscount.Text = null;
                textPersonalDiscount.ForeColor = Color.Black;
            }
        }

        private void textPersonalDiscount_Leave(object sender, EventArgs e)
        {
            if (textPersonalDiscount.Text == "")
            {
                textPersonalDiscount.Text = "0";
                textPersonalDiscount.ForeColor = Color.Gray;
            }
        }

        private void textClient_SelectedIndexChanged(object sender, EventArgs e)
        {
            dataBase.openConnection();
            if(textClient.Text != "")
            {
                SqlCommand sqlCommand_contract = new SqlCommand($"Select id_contract From Client Where name_organization = '{textClient.Text}'", dataBase.GetConnection());
                if (sqlCommand_contract.ExecuteScalar().ToString() != "")
                {
                    SqlCommand sqlCommand_discount = new SqlCommand($"Select [percent] From Contract Where id_contract = '{sqlCommand_contract.ExecuteScalar().ToString()}'", dataBase.GetConnection());
                    discount = Convert.ToDouble(sqlCommand_discount.ExecuteScalar().ToString());
                    labelDiscount.Text = $"По договору клиента внесена скидка {sqlCommand_discount.ExecuteScalar().ToString()}%";
                    textSummaDiscount.Text = Convert.ToString(WorkAdd.GetDiscount(Convert.ToDouble(textSumma.Text), Convert.ToDouble(discount + personalDiscount)));
                }
                else
                {
                    discount = 0;
                    labelDiscount.Text = $"Клиент не имеет договора";
                    textSummaDiscount.Text = Convert.ToString(WorkAdd.GetDiscount(Convert.ToDouble(textSumma.Text), Convert.ToDouble(discount + personalDiscount)));
                }
            }
        }

        private void textSumma_TextChanged(object sender, EventArgs e)
        {
            textSummaDiscount.Text = Convert.ToString(WorkAdd.GetDiscount(Convert.ToDouble(textSumma.Text), Convert.ToDouble(discount + personalDiscount)));
        }

        private void WorkUpd_Load(object sender, EventArgs e)
        {
            textPersonalDiscount.Text = "0";
            textPersonalDiscount.ForeColor = Color.Gray;
        }

        private void textPersonalDiscount_TextChanged(object sender, EventArgs e)
        {
            if (textPersonalDiscount.TextLength > 1)
            {
                string text = textPersonalDiscount.Text.Substring(0, textPersonalDiscount.Text.Length - 1);
                if (ContractAdd.GetCount(textDuration.Text) > 2)
                {
                    textPersonalDiscount.Text = text;
                    textPersonalDiscount.SelectionStart = textDuration.Text.Length;
                }
            }
        }
    }
}
